# Conditional build (--with/--without option)
#   --without milter
%define lgwver	0.40
%define withlogwatchfiles %([ %{mysig} = "ker.rhel3" ] && echo 1 || echo 0)

Summary: An antivirus toolkit for Unix.
Name:	 clamav
Version: 0.94.2
Release: 1.%{mysig}
License: GPL
Group:	 System Environment/Daemons
URL:	 http://www.clamav.net
Source0: http://prdownloads.sourceforge.net/clamav/clamav-%{version}.tar.gz
Source1: clamd.sh
Source2: clamav-milter.sh
Source3: freshclam.sh
Source4: clamav-milter.sysconfig
Source5: clamd.logrotate
Source6: freshclam.logrotate
Source7: http://www.schimkat.dk/clamav/clamav-logwatch-%{lgwver}.tar.gz
Source8: RPM-clamav.txt
Source9: RPM-clamav-milter.txt
Source10: clamav-milter.daily
Source11: clamav-freshclam.tmpwatch
Source12: ftp://ftp.suse.com/pub/projects/clamav/updateclamconf
Patch0:	  clamav-sendmail-8.11.patch
PreReq:	  perl grep
Requires: bzip2-libs gmp zlib
BuildRequires:	bzip2-devel gmp-devel zlib-devel autoconf automake
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

%description
Clam Antivirus is a powerful anti-virus scanner for Unix. It supports AMaViS,
Milter API, compressed files, uses the virus database from OpenAntivirus.org,
and includes a program for auto-updating.

%if %{!?_without_milter:1}%{?_without_milter:0}
%package  milter
Summary:  Clamav milter
Group:	  System Environment/Daemons
License:  GPL
Requires: %{name} = %{version}-%{release}
Requires: sendmail >= 8.11
Requires: sendmail-cf >= 8.11
Requires: tcp_wrappers
BuildRequires: sendmail-devel >= 8.11
BuildRequires: tcp_wrappers

%description 	milter
ClamAV sendmail filter using MILTER interface.
%endif

%package devel
Summary: Clamav - Development header files and libraries
Group:	 Development/Libraries
Requires: %{name} = %{version}-%{release}

%description 	devel
This package contains the development header files and libraries
necessary to develope your own clamav based applications.


%prep
%setup -q
%setup -q -D -a 7 -n %{name}-%{version}
# Sendmail-8.11 workaround
#%patch0 -p1 -b .811

%build
%configure \
	--program-prefix=%{?_program_prefix} \
	%{!?_without_milter:--enable-milter} \
	--disable-clamav \
	--enable-id-check \
	--with-tcpwrappers \
	--with-user=clamav \
	--with-group=clamav \
	--disable-zlib-vcheck \
	--with-dbdir=%{_localstatedir}/lib/clamav
#aclocal
%{__make}


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_initrddir}/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/
%if %{withlogwatchfiles}
install -d $RPM_BUILD_ROOT%{_sysconfdir}/log.d/scripts/services/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/log.d/conf/services/
%endif
install -d $RPM_BUILD_ROOT%{_localstatedir}/lib/clamav/
install -d $RPM_BUILD_ROOT%{_localstatedir}/log/clamav/
install -d $RPM_BUILD_ROOT%{_localstatedir}/run/clamav/
install -d $RPM_BUILD_ROOT%{_localstatedir}/spool/clamav/

%{__make} DESTDIR=$RPM_BUILD_ROOT install

%{?_without_milter:rm -f $RPM_BUILD_ROOT%{_mandir}/man8/clamav-milter.8*}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_initrddir}/clamd
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{_initrddir}/freshclam
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/clamd
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/freshclam
%if %{withlogwatchfiles}
install -m 755 clamav-logwatch-%{lgwver}/clamav $RPM_BUILD_ROOT%{_sysconfdir}/log.d/scripts/services/clamd
install -m 644 clamav-logwatch-%{lgwver}/clamav.conf $RPM_BUILD_ROOT%{_sysconfdir}/log.d/conf/services/clamd.conf
%endif
install -m 644 etc/clamd.conf $RPM_BUILD_ROOT%{_sysconfdir}/clamd.conf
install -m 644 etc/freshclam.conf $RPM_BUILD_ROOT%{_sysconfdir}/freshclam.conf
install -m 644 %{SOURCE8} RPM-clamav.txt
install -m 755 %{SOURCE11} $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/freshclam
install -m 755 %{SOURCE12} $RPM_BUILD_ROOT%{_bindir}/updateclamconf
mv clamav-logwatch-%{lgwver}/HOWTO HOWTO-logwatch.txt
touch $RPM_BUILD_ROOT%{_localstatedir}/log/clamav/clamav.log
touch $RPM_BUILD_ROOT%{_localstatedir}/log/clamav/freshclam.log

# Milter
%if %{!?_without_milter:1}%{?_without_milter:0}
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_initrddir}/clamav-milter
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/clamav-milter
%if %{withlogwatchfiles}
install -m 755 clamav-logwatch-%{lgwver}/clamav-milter $RPM_BUILD_ROOT%{_sysconfdir}/log.d/scripts/services/clamav-milter
install -m 644 clamav-logwatch-%{lgwver}/clamav-milter.conf $RPM_BUILD_ROOT%{_sysconfdir}/log.d/conf/services/clamav-milter.conf
%endif
install -m 644 %{SOURCE9} RPM-clamav-milter.txt
install -m 755 %{SOURCE10} $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/clamav-milter
%endif
#

# Custom config files
sed -e 's!^Example!#Example!;
        s!^#LogFile.*!LogFile /var/log/clamav/clamd.log!;
        s!^#LogFileMaxSize.*!LogFileMaxSize 0!;
        s!^#LogTime.*!LogTime yes!;
        s!^#LogSyslog.*!LogSyslog yes!;
        s!^#PidFile.*!PidFile /var/run/clamav/clamd.pid!;
        s!^#TemporaryDirectory.*!TemporaryDirectory /tmp!;
        s!^#DatabaseDirectory.*!DatabaseDirectory /var/lib/clamav!;
        s!^LocalSocket.*!#LocalSocket /var/run/clamav/clamd.sock!;
        s!^#FixStaleSocket.*!FixStaleSocket yes!;
        s!^#TCPSocket.*!TCPSocket 3310!;
        s!^#TCPAddr.*!TCPAddr 127.0.0.1!;
	s!^#MaxConnectionQueueLength.*!MaxConnectionQueueLength 30!;
        s!^#User.*!User clamav!;
        s!^#AllowSupplementaryGroups.*!AllowSupplementaryGroups yes!;
	s!^#ScanPE.*!ScanPE yes!;
	s!^#ScanELF.*!ScanELF yes!;
	s!^#DetectBrokenExecutables.*!DetectBrokenExecutables yes!;
        s!^#ArchiveBlockEncrypted.*!ArchiveBlockEncrypted yes!;' \
        etc/clamd.conf > $RPM_BUILD_ROOT%{_sysconfdir}/clamd.conf

sed -e 's!^Example.*!#Example!;
        s!^#DatabaseDirectory.*!DatabaseDirectory /var/lib/clamav!;
        s!^#UpdateLogFile.*!UpdateLogFile /var/log/clamav/freshclam.log!;
        s!^#DatabaseOwner.*!DatabaseOwner clamav!;
        s!^#NotifyClamd.*!NotifyClamd /etc/clamd.conf!;' \
        etc/freshclam.conf > $RPM_BUILD_ROOT%{_sysconfdir}/freshclam.conf

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
if [ -z "`/usr/bin/id -g clamav 2>/dev/null`" ]; then
       /usr/sbin/groupadd -r -f clamav 2>&1 || :
fi
if [ -z "`/usr/bin/id -u clamav 2>/dev/null`" ]; then
       /usr/sbin/useradd -r -M -d /tmp -s /sbin/nologin -c "Clam AntiVirus" -g clamav clamav 2>&1 || :
fi
# our old cronstrip created bogus file we should remove to allow miter daemon rum
[ -f '/var/lib/clamav/*.cvd' ] && rm -f '/var/lib/clamav/*.cvd' || :

%post
/sbin/ldconfig
/sbin/chkconfig --add clamd
/sbin/chkconfig --add freshclam
if [ $1 -ge 1 ]; then
  if grep -q ArchiveDetectEncrypted /etc/clamd.conf; then
    # changed option causing clamav to not run
    echo 'Fixing /etc/clamd.conf (ArchiveDetectEncrypted -> ArchiveBlockEncrypted)' 1>&2
    perl -pi -e 's/ArchiveDetectEncrypted/ArchiveBlockEncrypted/g' /etc/clamd.conf
  fi
fi

%preun
if [ $1 -eq 0 ]; then
  /sbin/service clamd stop > /dev/null 2>&1 || :
  /sbin/service freshclam stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del clamd
  /sbin/chkconfig --del freshclam
fi

%postun
/sbin/ldconfig
if [ $1 -eq 0 ]; then
  rm -rf %{_localstatedir}/run/clamav/
  /usr/sbin/userdel -r clamav > /dev/null 2>&1 || :
else
  /sbin/service clamd condrestart > /dev/null 2>&1 || :
  /sbin/service freshclam condrestart > /dev/null 2>&1 || :
fi


# Milter
%if %{!?_without_milter:1}%{?_without_milter:0}
%post milter
/sbin/chkconfig --add clamav-milter

%preun milter
if [ $1 -eq 0 ]; then
	/sbin/service clamav-milter stop > /dev/null 2>&1 || :
	/sbin/chkconfig --del clamav-milter
fi

%postun milter
if [ $1 -ge 1 ]; then
	/sbin/service clamav-milter condrestart > /dev/null 2>&1 || :
fi
%endif

%files
%defattr(-,root,root)
%doc AUTHORS BUGS ChangeLog COPYING FAQ HOWTO-logwatch.txt INSTALL NEWS README
%doc RPM-clamav.txt test UPGRADE
%doc docs/*.pdf docs/*.eps docs/html
#%lang(fr) %doc docs/French
#%lang(ja) %doc docs/Japanese
#%lang(pl) %doc docs/Polish
#%lang(pt) %doc docs/Portugese
#%lang(sp) %doc docs/Spanish
#%lang(tk) %doc docs/Turkish
%config(noreplace) %{_sysconfdir}/clamd.conf
%config(noreplace) %{_sysconfdir}/freshclam.conf
%{_sysconfdir}/cron.daily/freshclam
%{_sysconfdir}/logrotate.d/clamd
%{_sysconfdir}/logrotate.d/freshclam
%if %{withlogwatchfiles}
%{_sysconfdir}/log.d/scripts/services/clamd
%{_sysconfdir}/log.d/conf/services/clamd.conf
%endif
%{_initrddir}/clamd
%{_initrddir}/freshclam
%{_bindir}/*
%{_sbindir}/clamd
%{_libdir}/libclamav.so*
%{_libdir}/libclamunrar.so*
%{_libdir}/libclamunrar_iface.so*
%attr(0755,clamav,clamav) %dir %{_localstatedir}/lib/clamav
%attr(0644,clamav,clamav) %config(noreplace) %verify(user group mode) %{_localstatedir}/lib/clamav/main.cvd
%attr(0644,clamav,clamav) %config(noreplace) %verify(user group mode) %{_localstatedir}/lib/clamav/daily.cvd
%dir %attr(0755,clamav,clamav) %{_localstatedir}/log/clamav
%dir %attr(0755,clamav,clamav) %{_localstatedir}/run/clamav
%ghost %{_localstatedir}/log/clamav/clamav.log
%ghost %{_localstatedir}/log/clamav/freshclam.log
%{_mandir}/man1/*
%{_mandir}/man5/clamd.conf.5.gz
%{_mandir}/man5/freshclam.conf.5.gz
%{_mandir}/man8/clamd.8.gz

# Milter
%if %{!?_without_milter:1}%{?_without_milter:0}
%files milter
%defattr(-,root,root)
%doc RPM-clamav-milter.txt
%config(noreplace) %{_sysconfdir}/sysconfig/clamav-milter
%{_initrddir}/clamav-milter
%{_sysconfdir}/cron.daily/clamav-milter
%if %{withlogwatchfiles}
%{_sysconfdir}/log.d/scripts/services/clamav-milter
%{_sysconfdir}/log.d/conf/services/clamav-milter.conf
%endif
%{_sbindir}/clamav-milter
%{_mandir}/man8/clamav-milter.8.gz
%attr(0700,clamav,clamav) %{_localstatedir}/spool/clamav
%endif

%files devel
%defattr(-,root,root)
%{_libdir}/libclamav.so
%{_libdir}/*.a
%{_libdir}/*.la
%{_includedir}/*.h
%{_libdir}/pkgconfig/libclamav.pc

%changelog
* Wed Nov 26 2008 Milan Kerslager <kerslage@linux.cz> 0.94.2-1.ker.rhel4
- updated to the latest release

* Mon Nov 17 2008 Milan Kerslager <kerslage@linux.cz> 0.94.1-1.ker.rhel4
- updated to the latest release

* Fri Feb 15 2008 Milan Kerslager <kerslage@linux.cz> 0.92.1-2.ker.rhel4
- updated to the latest release
- include libclamunrar*

* Tue Nov 20 2007 Milan Kerslager <kerslage@linux.cz> 0.91.2-1.ker.rhel4
- updated to the latest release

* Mon Jul 23 2007 Milan Kerslager <kerslage@linux.cz> 0.91.1-2.ker.rhel4
- updated to the latest release
- fix /etc/cron.daily/freshclam

* Sat Jun 02 2007 Milan Kerslager <kerslage@linux.cz> 0.90.3-1.ker.rhel4
- updated to the latest release

* Fri Apr 13 2007 Milan Kerslager <kerslage@linux.cz> 0.90.2-2.ker.rhel4
- fix autoremove (always return success)

* Fri Apr 13 2007 Milan Kerslager <kerslage@linux.cz> 0.90.2-1.ker.rhel4
- update to the latest release
- autoremove bogus /var/lib/clamav/*.cvd

* Wed Apr 11 2007 Milan Kerslager <kerslage@linux.cz> 0.90.1-2.ker.rhel4
- daily freshclam cronscript needs #!/bin/bash

* Wed Feb 28 2007 Milan Kerslager <kerslage@linux.cz> 0.90.1-1.ker.rhel4
- updated to the latest release
- add updateclamconf for converting old clamd.conf and freshclam.conf
  from releases before 0.90
- removed --dont-log-clean from /etc/sysconfig/clamav-milter
  (parameter has been removed from the source)

* Mon Dec 25 2006 Milan Kerslager <kerslage@linux.cz> 0.88.7-1.ker.rhel4
- updated to the latest release

* Wed Nov 08 2006 Milan Kerslager <kerslage@linux.cz> 0.88.6-1.ker.rhel4
- updated to the latest release

* Mon Oct 16 2006 Milan Kerslager <kerslage@linux.cz> 0.88.5-1.ker.rhel4
- updated to the latest release

* Sun Aug 13 2006 Milan Kerslager <kerslage@linux.cz> 0.88.4-0.ker.rhel4
- updated to the latest release

* Wed Jul 05 2006 Milan Kerslager <kerslage@linux.cz> 0.88.3-0.ker.rhel4
- updated to the latest release

* Sat May 20 2006 Milan Kerslager <kerslage@linux.cz> 0.88.2-0.ker.rhel4
- updated to the latest release

* Wed Apr 05 2006 Milan Kerslager <kerslage@linux.cz> 0.88.1-0.ker.rhel4
- updated to the latest release

* Mon Feb 06 2006 Milan Kerslager <kerslage@linux.cz> 0.88-0.ker.rhel4
- updated to the latest release

* Tue Nov 29 2005 Milan Kerslager <kerslage@linux.cz> 0.87.1-0.ker.rhel4
- updated to the latest release

* Sun Sep 25 2005 Milan Kerslager <kerslage@linux.cz> 0.87-0.ker.rhel4
- updated to the latest release

* Wed Aug 10 2005 Milan Kerslager <kerslage@linux.cz> 0.86.2-1.ker.rhel4
- security update

* Tue Jun 28 2005 Milan Kerslager <kerslage@linux.cz> 0.86.1-1.ker.rhel4
- logwatch has its own config files in RHEL4

* Sat Jun 25 2005 Milan Kerslager <kerslage@linux.cz> 0.86.1-0.ker.rhel4
- updated to the latest version

* Tue Jun 07 2005 Milan Kerslager <kerslage@linux.cz> 0.85.1-0.ker.rhel3
- updated to the latest version

* Fri Mar 04 2005 Milan Kerslager <kerslage@linux.cz> 0.83-0.ker.rhel4
- rebuild for RHEL4
- add --disable-zlib-vcheck as zlib is not vulnerable and is patched

* Mon Feb 14 2005 Milan Kerslager <kerslage@linux.cz> 0.83-0.ker.rhel3
- update
- doc/html is back

* Mon Feb 07 2005 Milan Kerslager <kerslage@linux.cz> 0.82-0.ker.rhel3
- updated to latest stable release

* Sat Jan 29 2005 Milan Kerslager <kerslage@linux.cz> 0.81-0.ker.rhel3
- updated to latest stable release
- update to clamav-logwatch-0.40
- removed doc/html (no more in the package), added clam.eps (doc/*.eps)
- RPM-clamav-milter.txt updated as clamav-milter does not need clamd anymore
  (because using libclamav)

* Mon Nov 01 2004 Milan Kerslager <kerslage@linux.cz> 0.80-0.2.ker.rhel3
- remove Example from /etc/freshclam.conf (this causes to not update ClamAV virus DB)

* Thu Oct 21 2004 Milan Kerslager <kerslage@linux.cz> 0.80-0.1.ker.rhel3
- /etc/log.d/scripts/services/clamav -> /etc/log.d/scripts/services/clamd

* Wed Oct 20 2004 Milan Kerslager <kerslage@linux.cz> 0.80-0.ker.rhel3
- updated to latest release
- clamav.conf renamed to clamd.conf
- more options in clamd.conf

* Mon Jul 26 2004 Milan Kerslager <kerslage@linux.cz> 0.75-0.ker.rhel3
- updated to latest release

* Wed Jul 14 2004 Milan Kerslager <kerslage@linux.cz> 0.74-0.ker.rhel3
- updated to latest release

* Fri Jun 04 2004 Milan Kerslager <kerslage@linux.cz> 0.72-1.ker.rhel3
- update to latest release
- %dir u adresare %{_localstatedir}/log/clamav (file listed twice)

* Wed May 19 2004 Milan Kerslager <kerslage@linux.cz> 0.71-0.1.ker.rhel3
- update to latest release

* Wed Apr 21 2004 Milan Kerslager <kerslage@linux.cz> 0.70rc-4.0.70final.ker.rhel3
- clamav-freshclam.tmpwatch
- update from Kristof: clamd.logrotate, freshclam.logrotate, clamd.sh, freshclam.sh

* Tue Apr 20 2004 Milan Kerslager <kerslage@linux.cz> 0.70rc-2.0.70final.ker.rhel3
- wrong version workaround (even read http://www.fedora.us/wiki/PackageNamingGuidelines)
- ArchiveDetectEncrypted -> ArchiveBlockEncrypted (conf, %postun)

* Thu Apr 13 2004 Milan Kerslager <kerslage@linux.cz> 0.70rc-1.20040413cvs.ker.rhel3
- updated to latest CVS version because repeated segfaults
  (seems to be stable after 2 days)

* Tue Mar 23 2004 Milan Kerslager <kerslage@linux.cz> 0.70rc-1.ker.rhel3
- initial package based on Kristof and Dag packages
  http://crash.fce.vutbr.cz/crash-hat
